

#    MIDAS Access Client  for the  XR3BAccess service


package require MIDASAccessClient    ;#   load default support procedures

global MIDAS_XR3BAccessClient_Exists
set MIDAS_XR3BAccessClient_Exists 1

global XR3BAccessServerHost XR3BAccessServerPort

if {[info exists XR3BAccessServerHost] == 0} then {set XR3BAccessServerHost localhost}
if {[info exists XR3BAccessServerPort] == 0} then {set XR3BAccessServerPort 8015}


variable uri "urn:XR3BAccessServer"
variable proxy "http://$XR3BAccessServerHost:$XR3BAccessServerPort/XR3BAccessServer"

set XR3BAccessServerTimeOut 10000

proc XR3BAccessClient_Configure {} {
   global XR3BAccessServerHost XR3BAccessServerPort
   variable proxy

   set proxy "http://$XR3BAccessServerHost:$XR3BAccessServerPort/XR3BAccessServer"

   foreach method [info procs XR3BAccessClient__*] {catch {SOAP::configure $method -proxy $proxy}}
}

SOAP::create XR3BAccessClient__Verbose -proxy $proxy -uri $uri -timeout 1000 \
     -name  AccessServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create XR3BAccessClient__Get -proxy $proxy -uri $uri -timeout $XR3BAccessServerTimeOut \
     -name Get \
     -params {Address int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create XR3BAccessClient__Set -proxy $proxy -uri $uri -timeout $XR3BAccessServerTimeOut \
     -name Set \
     -params {Address int Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply


package provide XR3BAccessClient 1.0
