
#    Note:  This is loaded into the namespace  ASIC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {
    
    variable JS ""
    variable LogFlag
    
    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}
    
    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1
    
    variable ShowLogFlag 0
    
    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    
    variable JS ""
    
    variable allmodules 0
    
    for {set i 0} {$i <= 6} {incr i} {variable OptC00.$i; set OptC00.$i 0}
    
    variable TestPulse_Width 0
    
    variable p_width 100
    variable p_delay 10000
    variable p_number 1024
    
    proc  show_variables {} {
	variable allmodules 
	
	InsertLog "R3B4K = $::R3B::R3B4K"
	InsertLog "all modules = $allmodules"
	
	for {set i 0} {$i <= 6} {incr i} {variable OptC00.$i; InsertLog "C00.$i = [set OptC00.$i]"}
	
	variable TestPulse_Width 
	set TestPulse_Width [ReadR3BRegister [expr 0x300 + 1]]
	InsertLog "TestPulse_Width = $TestPulse_Width"
    }
    
    proc do_redisplay {} {
	
	for {set i 0} {$i <= 6} {incr i} {
	    variable OptC00.$i
	    set OptC00.$i [ReadR3BRegister [expr 0x300 + $i]]
	}
	
	variable TestPulse_Width 
	set TestPulse_Width [ReadR3BRegister [expr 0x300 + 1]]
    }
    
    proc do_setOptC00 {i vl} {
	variable allmodules
	
	set BAK $::R3B::R3B4K   ;#  save
	
	foreach R3B4K $::R3B::ModuleMenu {
	    if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue
	    
	    set ::R3B::R3B4K $R3B4K
	    WriteR3BRegister 0x300 0
	    WriteR3BRegister [expr 0x300 + $i] $vl
	    
	    if {$i == 1 || $i == 2 || $i == 3 || $i == 4} {
		WriteR3BRegister 0x300 0x14   ;#  reset to load values
		WriteR3BRegister 0x300 0
	    }
	    
	}
	
	set ::R3B::R3B4K $BAK   ;#  restore
    }
    
    proc set_TestPulse_Width {vl} {
	WriteR3BRegister [expr 0x300 + 1] $vl
    }
    
    proc set_ASICValidate {n} {
	
	#    bits VM0 and VM1 of ASIC REG1    n = 1 (enable for calibrate);   n = 3 (disable)
	
	foreach SIDE $::R3B::SIDEList {
	    foreach ASIC [set ::R3B::ASICList$SIDE] {
		set vl [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1]]     ;#  REG1
		set vl [expr ($vl & 0xc0) + ($n << 4)] 
		WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1] $vl
	    }
	}
	
    }
    
    proc do_TestPulse1 {p_w p_d p_n} {
	
	# Set current values. 
	set p_width  $p_w;
	set p_delay  $p_d;
	set p_number $p_n;
	
	# Stop any injection of pulses.
	WriteR3BRegister 0x300 0
	# Reset to load values.
	WriteR3BRegister 0x300 4
	
	# Set registers:
	# reg 1 - p_width
	# reg 2 - p_delay
	# reg 3 - p_number
	
	WriteR3BRegister [expr 0x300 + 1] $p_width
	WriteR3BRegister [expr 0x300 + 2] $p_delay
	WriteR3BRegister [expr 0x300 + 3] $p_number
	
	# Enable test pulse injection
	set_ASICValidate 1
	# Start the injection of pulses.
	WriteR3BRegister 0x300 3
	
    }

    proc do_TestPulse2 {p_w p_d p_n} {
	
	variable write_ptr1 
	variable write_ptr2
	set write_ptr1 -1
	set write_ptr2 [ReadR3BRegister [expr 0x100 + 7]]
	
	do_TestPulse1 $p_w $p_d $p_n
	
	variable tm_stamp_msb
	variable tm_stamp_lsb
	variable tm_stamp_1
	variable tm_stamp_2
	
	# Update the variable.
	variable upd
	set upd [ReadR3BRegister 0x100]   ;# update reg 8 => 12
        WriteR3BRegister 0x100 [expr $upd | 0x4]
        WriteR3BRegister 0x100 $upd
	
	set tm_stamp_msb [ReadR3BRegister [expr 0x100 + 11]]
	set tm_stamp_lsb [ReadR3BRegister [expr 0x100 + 10]]
	set tm_stamp_1 [expr (($tm_stamp_msb & 0xFFFFFFFF) << 32) + ($tm_stamp_lsb & 0xFFFFFFFF)]
	
	set tm_stamp_2 $tm_stamp_1
	
	while {$write_ptr2 != $write_ptr1 || abs($tm_stamp_1 - $tm_stamp_2) < 100000} {
	    set write_ptr1 $write_ptr2
	    set write_ptr2 [ReadR3BRegister [expr 0x100 + 7]]
	    
	    if {$write_ptr2 == $write_ptr1} {
		# Update and read register for time stamp.
		set upd [ReadR3BRegister 0x100]   ;# update reg 8 => 12
		WriteR3BRegister 0x100 [expr $upd | 0x4]
		WriteR3BRegister 0x100 $upd
		set tm_stamp_msb [ReadR3BRegister [expr 0x100 + 11]]
		set tm_stamp_lsb [ReadR3BRegister [expr 0x100 + 10]]
		set tm_stamp_1 [expr (($tm_stamp_msb & 0xFFFFFFFF) << 32) + ($tm_stamp_lsb & 0xFFFFFFFF)]
	    } else {
		# Update and read register for time stamp.
		set upd [ReadR3BRegister 0x100]   ;# update reg 8 => 12
		WriteR3BRegister 0x100 [expr $upd | 0x4]
		WriteR3BRegister 0x100 $upd
		set tm_stamp_msb [ReadR3BRegister [expr 0x100 + 11]]
		set tm_stamp_lsb [ReadR3BRegister [expr 0x100 + 10]]
		set tm_stamp_1 [expr (($tm_stamp_msb & 0xFFFFFFFF) << 32) + ($tm_stamp_lsb & 0xFFFFFFFF)]
		set tm_stamp_2 $tm_stamp_1
	    } 
	} 
	
    }
    
    proc do_TestPulse3 {params} {
	
	# Store old values.
	# variable p_width_old 
	# variable p_delay_old 
	# variable p_number_old 
	
	# set p_width_old  [ReadR3BRegister [expr 0x300 + 1] ]
	# set p_delay_old  [ReadR3BRegister [expr 0x300 + 2] ]
	# set p_number_old [ReadR3BRegister [expr 0x300 + 3] ]
	
	variable pulse_width_minimum [lindex $params 1]
	variable pulse_width_maximum [lindex $params 2]
	variable pulse_width_total_step [lindex $params 3]
	variable pulse_number [lindex $params 4]
	variable pulse_delay [lindex $params 5]
	
	
	
	variable pulse_width_step_size
	set pulse_width_step_size [expr round( ($pulse_width_maximum - $pulse_width_minimum)/$pulse_width_total_step )]
	
	InsertLog "$pulse_width_step_size"
	
	for {set i $pulse_width_minimum} {$i<= $pulse_width_maximum} { set i [expr $i+ $pulse_width_step_size]} {
	    do_TestPulse2 $i $pulse_delay $pulse_number
	    
	    
	}
	
	# Restore old values (to be checked).
	# WriteR3BRegister [expr 0x300 + 1] $p_width_old
	# WriteR3BRegister [expr 0x300 + 2] $p_delay_old
	# WriteR3BRegister [expr 0x300 + 3] $p_number_old
    }
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag

	set cgidata [ncgi::nvlist]
	
	if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

	if {[llength $cgidata] == 0} then {return}

	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {

		set w [first [lindex $cgidata 1]]
		set vl [second [lindex $cgidata 1]]
		set vl2 [third [lindex $cgidata 1]]
		set vl3 [fourth [lindex $cgidata 1]]

		switch -glob $w {
		    
		    RESET    {set started 0}
		    CLEAR    {EmptyLog}
		    ELOG     {PrintLog}
		    RELOAD   {}
		    VARIABLES {show_variables}
		    
		    HIDE     {set ShowLogFlag 0}
		    SHOW     {set ShowLogFlag 1}
		    LOGON    {set LogFlag 1}
		    LOGOFF   {set LogFlag 0}
		    
		    TESTPULSE {do_TestPulse3 [lindex $cgidata 1]}
		    TESTPULSE1 {do_TestPulse1 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]] [fourth [lindex $cgidata 1]]}
		    TESTPULSE2 {do_TestPulse3 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]] [fourth [lindex $cgidata 1]]}
		    
		    TESTPULSE_WIDTH {set TestPulse_Width $vl; InsertLog "$TestPulse_Width"; set_TestPulse_Width $vl}
		    
		    TEST1 {
			InsertLog "GO!";
			do_inquiredevices
			#set z [catch {::namespace inscope ::urn:TapeServer InquireAvailableDevices} msg]
			# set z [catch {::namespace inscope ::urn:TapeServer do_allocatedevice} msg]
			# InsertLog "$z"
			# do_openfile
		    }
		    TEST2 {
			InsertLog "STOP!"
			# set z [catch {::namespace inscope ::urn:TapeServer do_deallocatedevice} msg]
		    }
		    
		    MainLog {}
		    undefined {}
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
        do_redisplay
    }
    
}   ;# end of if {$started == 0}


