
#    Note:  This is loaded into the namespace  R3B

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    variable SIDEList
    if {![info exists SIDEList]} {set SIDEList {0}}
    variable SIDE [first $SIDEList]
    variable ASICList1 {0}
    if {![info exists ASICList1]} {set ASICList1 {0}}
    variable ASICList2 {0}
    if {![info exists ASICList2]} {set ASICList2 {0}}


   proc  show_variables {} {
       variable allmodules
       global R3BASICBase

       InsertLog "Asic Base = $R3BASICBase"

       InsertLog "SIDE = $::R3B::SIDE"
       InsertLog "ASIC = $::R3B::ASIC"

       InsertLog "SIDEs = $::R3B::SIDEList"

       foreach SIDE $::R3B::SIDEList {
           InsertLog "ASICs = [set ::R3B::ASICList$SIDE]"
       }

       InsertLog "all modules = $allmodules"
   }

   proc probe_i2c {} {
       variable SIDEList
       variable ASIC
       variable SIDE

       set SIDEList {}

       foreach SIDE {0 1} {

          variable ASICList$SIDE
          set ASICList$SIDE {}

          foreach ASIC {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15} {
            set i 0
            set vl [time {ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]}]
            if {[first $vl] < 60000} {lappend ASICList$SIDE $ASIC}
          }

          if {[set ASICList$SIDE] == {}} {
            set ASIC "-"
            InsertLog "SIDE $SIDE not present or empty"
          } else {
            set ASIC [first [set ASICList$SIDE]]
            lappend SIDEList $SIDE
            InsertLog "SIDE $SIDE: ASICs discovered [set ASICList$SIDE]"
          }
       }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::R3B::R3B4k $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   I2C       {probe_i2c}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

}   ;# end of if {$started == 0}




