
#    Note:  This is loaded into the namespace  RDOUT

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {
    
    variable JS ""
    variable INFO ""
    variable LogFlag
    
    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}
    
    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1
    
    variable ShowLogFlag 0
    
    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    
    variable JS ""
    variable INFO ""
    
    variable allmodules 0
    
    for {set i 0} {$i <= 12} {incr i} {variable Opt400.$i 0}
    
    
    proc  show_variables {} {
	variable allmodules 
	
	InsertLog "R3B4K = $::R3B::R3B4K"
	InsertLog "all modules = $allmodules"
	
	for {set i 0} {$i <= 12} {incr i} {variable Opt400.$i; InsertLog "400.$i = [set Opt400.$i]"}
    }
    
    proc do_redisplay {} {
	variable Opt400.0
	
	set Opt400.0 [ReadR3BRegister 0x100]   ;# update reg 8 => 12
	WriteR3BRegister 0x100 [expr [set Opt400.0] | 0x4]
	WriteR3BRegister 0x100 [set Opt400.0] 
	
	for {set i 0} {$i <= 12} {incr i} {
	    variable Opt400.$i
	    set Opt400.$i [ReadR3BRegister [expr 0x100 + $i]]
	}
    }
    
    proc do_setOpt400 {i vl} {
	variable allmodules
	
	set BAK $::R3B::R3B4K   ;#  save
	
	foreach R3B4K $::R3B::ModuleMenu {
	    if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue
	    
	    set ::R3B::R3B4K $R3B4K
	    WriteR3BRegister [expr 0x100 + $i] $vl
	}
	
	set ::R3B::R3B4K $BAK   ;#  restore
    }
    
    proc do_dmaTestMode {} {
	variable allmodules
	
	set BAK $::R3B::R3B4K   ;#  save
	
	foreach R3B4K $::R3B::ModuleMenu {
	    if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue
	    
	    set ::R3B::R3B4K $R3B4K
	    
	    WriteR3BRegister 0x100 2        ;#  set reset DMA
	    WriteR3BRegister 0x100 0        ;#  and clear
	    
	    WriteR3BRegister 0x102 0x0f000000   ;# set DMA MEM Base
	    WriteR3BRegister 0x103 64         ;# set DMA burst length  (minimum)
	    WriteR3BRegister 0x105 [expr (16*1024*1024)/64]   ;# set DMA MEM Length (units of burst length) (0x01000000/64) == (16M/64)
	    
	    WriteR3BRegister 0x104 256         ;# set DMA Buffer Length (units of burst length) 
	    
	    WriteR3BRegister 0x100 2        ;#  set reset DMA to load parameters
	    WriteR3BRegister 0x100 0        ;#  and clear
	    
	    WriteR3BRegister 0x106 0        ;#  and clear rd_ptr
	    
	}
	
	set ::R3B::R3B4K $BAK   ;#  restore
    }
    
    proc do_dmaFullMode {} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          set ::R3B::R3B4K $R3B4K

          WriteR3BRegister 0x100 2        ;#  set reset DMA
          WriteR3BRegister 0x100 0        ;#  and clear

          WriteR3BRegister 0x102 0x0f000000   ;# set DMA MEM Base
          WriteR3BRegister 0x103 2048         ;# set DMA burst length   (maximum)
          WriteR3BRegister 0x105  [expr (16*1024*1024)/2048] ;# set DMA MEM Length (units of burst length) (0x01000000/2048) == (16M/2K)

          WriteR3BRegister 0x104 256      ;# set DMA Buffer Length (units of burst length) 32 buffers (512K/2K)

          WriteR3BRegister 0x100 2        ;#  set reset DMA to load parameters
          WriteR3BRegister 0x100 0        ;#  and clear

          WriteR3BRegister 0x106 0        ;#  and clear rd_ptr

      }

      set ::R3B::R3B4K $BAK   ;#  restore
   }



   proc do_dma {vl} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          set ::R3B::R3B4K $R3B4K
          WriteR3BRegister [expr 0x100] $vl
      }

      set ::R3B::R3B4K $BAK   ;#  restore
   }

   proc do_showbuffer {} {

     set rc [catch {exec /MIDAS/R3B/rddma.exe} m]

     Information "[second [split $m =]]"

  }

   proc do_expert {cmd} {

       switch $cmd {

          do_TestMode {do_dmaTestMode}
          do_FullMode {do_dmaFullMode}
          do_Enable   {do_dma 1}
          do_Disable  {do_dma 0}
          do_ShowBuffer {do_showbuffer}

          default {}
       }
   }
 
   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       
       set cgidata [ncgi::nvlist]
       
       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}
       
       if {[llength $cgidata] == 0} then {return}
       
       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
	       
	       set w [first [lindex $cgidata 1]]
	       set vl [second [lindex $cgidata 1]]
	       
               switch -glob $w {
		   
                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
		   
                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
		   
                   MODULE     {set ::R3B::R3B4K $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
		   
                   OPTS400     {do_setOpt400 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {do_expert $vl}
		   
                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
       }
       do_redisplay
   }
    
}   ;# end of if {$started == 0}




