
#    Note:  This is loaded into the namespace  R3B_SpecSave

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

#     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    global env
    variable SpecBase [file join $env(MIDASBASE) SpecData R3B]

   variable index 0
   variable selected -1
   variable asicselected 0xffffffff


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=$selected"
#        InsertLog "DBPath = $::R3B::DBRootName/$::R3B::DBNodeBase/$::R3B::DBNodeName"

        foreach R3B4K $::R3B::ModuleMenu {InsertLog "$R3B4K"}

#        InsertLog "HasBeenConfigured = [ReadRegister HasBeenConfigured]"
#        InsertLog "HasBeenRestored = [ReadRegister HasBeenRestored]"
   }

      proc Selection {} {
          variable selected

           set i 1
           foreach item $::R3B::ModuleMenu {
               set selected [expr $selected | (1 << $i)]
               incr i
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }

      proc do_SelectASIC {i} {
         variable asicselected
         
         if {$i < 0} {set asicselected 0xffffffff; return}

         set asicselected [expr $asicselected | (1 << [expr 31-$i])]
      }

      proc do_UnSelectASIC {i} {
         variable asicselected
         
         if {$i < 0} {set asicselected 0; return}

         set asicselected [expr $asicselected & ~(1 << [expr 31-$i])]
      }

    proc do_setopt {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqSetOption
        global MIDAS_DataAcquisitionControlServer_Exists
	
        set AcqSetOption $option
	
	if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {
	    
	    set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoOption "$AcqSetOption"} m]
	} else {
	    
	    if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
	    }
	    set rc [catch {DataAcquisitionControlClient__DoOption "$AcqSetOption"} m]
	}
	
        if {$rc != 0} {
            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
	    #            InsertLog "DO OPTION returned $m ([format "0x%x" $m])"
	    set rc [second $m]
        }
	
        return $rc
	
    }

    proc do_getstate {} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetState} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__GetState} m]
      }

        if {$rc != 0} {
            InsertLog "DO GETSTATE returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
#            InsertLog "DO GETSTATE returned $m"
            set rc [second $m]
        }

       return $rc

     }

      proc do_Save {} {
        variable SpecBase
	  variable selected
	  variable asicselected
	  
	  if {$selected == 0} {Selection}
	  
	  InsertLog "Saving R3B4K histograms to $SpecBase"
	  
	  set BAK $::R3B::R3B4K   ;# save
	  
	  set i 0
	  foreach R3B4K $::R3B::ModuleMenu {
	      incr i
	      if {[expr ($selected >> $i) & 1] == 0} {continue}
	      
	      set ::DataAcquisition::ACQSERVER $R3B4K
	      do_setopt "HistogramSave=$SpecBase $asicselected"
	      
	      InsertLog "R3B4K histograms saved for $::DataAcquisition::ACQSERVER"
	  }
	  
	  set ::R3B::R3B4K $BAK    ;# restore
	  
	  InsertLog "R3B4K histograms saved"
	  
	  #        Elog INFORMATION "R3B4K histograms saved to $::R3B::DBRootName/$::R3B::DBNodeBase"
	  
	  #        do_DBUpdate
      }
    
    proc do_DBName {vl} {
	global Options
	
	set ::R3B::DBNodeBase $vl
	DBCreateNode $::R3B::DBRootName/$::R3B::DBNodeBase
	
	InsertLog "Data Base node $::R3B::DBRootName/$::R3B::DBNodeBase contains [DBGetNodes $::R3B::DBRootName/$::R3B::DBNodeBase *]"
    }
    
    proc do_DBUpdate {} {
	variable DBNameList
	
	set DBNameList {}
	foreach item [DBGetNodes $::R3B::DBRootName *] {
	    if {$item == "Options"} continue
	    lappend DBNameList $item
	}
    }
    
    
    proc  do_click {}  {
	variable cgidata
	variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                SAVE     {do_Save}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}
                SELECTASIC    {do_SelectASIC [lindex $w 1]}
                UNSELECTASIC  {do_UnSelectASIC [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

   Selection

#     do_DBUpdate

#     load_Options
#     set ::R3B::DBNodeBase $Options(ASIC.settings)
#     set ::R3B::DBNodeBase Histograms


}  ;# end of if {$started == 0}

